PAGE 1                                                                                     0100 ; NXIO.M65                0105 ;                0110 ; NEW CIO/XIO INTERFACE                0115 ;                0120 ; SETUP IOCB WITH THE SUPPLIED                0125 ; ARGUMENTS AND CALL CIO                0130 ;                0135 ; USR 2, 4, 5, or 6 ARGUMENTS:                0140 ; CHANNEL == IOCB CHANEL (LOW BYTE)                0145 ; COMMAND == CIO COMMAND (LOW BYTE)                0150 ; BUF ADR == ADDRESS OF BUFFER                 0155 ; BUF LEN == LENGTH OF BUFFER                0160 ; ICAX1   == CIO ICAX1 VALUE (LOW BYTE)                0165 ; ICAX2   == CIO ICAX2 VALUE (LOW BYTE)                0170 ;                0175 ; RETURN VALUE IS CIOV RESULT IN Y REG                0180 ;    =00D4       0185 ZRET =  $D4     ; FR0 $D4/$D5 Return Value                0190 ;    =E456       0195 CIOV =  $E456   ; CIO Vector                0200 ;    =0340       0205 IOCB =  $0340   ; Base IO Control Block    =0340       0210 ICHID = IOCB+$00 ; Handler ID    =0341       0215 ICDNO = IOCB+$01 ; Device number    =0342       0220 ICCMD = IOCB+$02 ; ** CIO Command    =0343       0225 ICSTA = IOCB+$03 ; CIO Status    =0344       0230 ICBAL = IOCB+$04 ; ** Buffer address (low)    =0345       0235 ICBAH = IOCB+$05 ; ** Buffer address (high)     =0346       0240 ICPTL = IOCB+$06 ; Put char routine (low)    =0347       0245 ICPTH = IOCB+$07 ; Put char routine (high)    =0348       0250 ICBLL = IOCB+$08 ; ** Buffer length (low)    =0349       0255 ICBLH = IOCB+$09 ; ** Buffer length (high)      =034A       0260 ICAX1 = IOCB+$0A ; ** Aux Byte 1    =034B       0265 ICAX2 = IOCB+$0B ; ** Aux Byte 2      =034C       0270 ICAX3 = IOCB+$0C ; Aux Byte 3      =034D       0275 ICAX4 = IOCB+$0D ; Aux Byte 4      =034E       0280 ICAX5 = IOCB+$0E ; Aux Byte 5      =034F       0285 ICAX6 = IOCB+$0F ; Aux Byte 6                  0290 ;0000            0295     .OPT OBJ                0300 ;0000            0305     *=  $9000   ; Arbitrary. this is relocatable                0310 ;9000            0315 INIT9000 A0FF       0320     LDY #$FF    ; Make the return9002 84D4       0325     STY ZRET    ; value -1 ($FFFF)9004 84D5       0330     STY ZRET+1  ; by default.                0335 ;9006 68         0340     PLA         ; Get argument count9007 F054       0345     BEQ BYE     ; Shortcut for no args.                0350 ;9009 A8         0355     TAY                 0360 ;900A C901       0365     CMP #$01    ; One arg is not enough.900C F008       0370     BEQ DISPOSE                0375 ;900E C903       0380     CMP #$03    ; Three args is not supported.PAGE 2                                                                     9010 F004       0385     BEQ DISPOSE                0390 ;9012 C907       0395     CMP #$07    ; More than six is not valid.9014 9006       0400     BCC DO_CHANNEL ; All good. Ready to pull args.                0405 ;                0410 ; Bad arg count.  Clean up for exit.                0415 ;9016            0420 DISPOSE ;       Any number of arguments9016 68         0425     PLA 9017 68         0430     PLA 9018 88         0435     DEY 9019 D0FB       0440     BNE DISPOSE901B 60         0445     RTS         ; Abandon ship.                0450 ;                0455 ; Pull channel and multiply times 16                0460 ;901C            0465 DO_CHANNEL ;    Arg 1 = Channel901C 88         0470     DEY         ; subtract one arg901D 68         0475     PLA         ; discard high byte901E 68         0480     PLA         ; Channel number901F C908       0485     CMP #$08    ; More than 7 channels9021 B0F3       0490     BCS DISPOSE ; is invalid.9023 0A         0495     ASL A       ; * 29024 0A         0500     ASL A       ; * 49025 0A         0505     ASL A       ; * 89026 0A         0510     ASL A       ; * 169027 AA         0515     TAX                 0520 ;9028            0525 DO_ICCMD ;      Arg 2 = Command9028 68         0530     PLA         ; discard high byte9029 68         0535     PLA         ; command byte902A 9D4203     0540     STA ICCMD,X ; Store Command in IOCB902D 88         0545     DEY         ; subtract one arg 902E F022       0550     BEQ DO_CIO                0555 ;9030            0560 DO_ICBA ;       Arg 3 = Buffer Address9030 68         0565     PLA         ; Address high byte9031 9D4503     0570     STA ICBAH,X9034 68         0575     PLA         ; Address low byte9035 9D4403     0580     STA ICBAL,X9038 88         0585     DEY         ; subtract one arg                  0590 ;9039            0595 DO_ICBL ;       Arg 4 = Buffer Length9039 68         0600     PLA         ; Length high byte903A 9D4903     0605     STA ICBLH,X903D 68         0610     PLA         ; Length low byte903E 9D4803     0615     STA ICBLL,X9041 88         0620     DEY         ; subtract one arg  9042 F00E       0625     BEQ DO_CIO                0630 ;9044            0635 DO_ICAX1 ;      Arg 5 = Aux Byte 19044 68         0640     PLA         ; discard high byte9045 68         0645     PLA         ; Aux byte9046 9D4A03     0650     STA ICAX1,X ; Store AUX1 in IOCB9049 88         0655     DEY         ; subtract one arg 904A F006       0660     BEQ DO_CIO                0665 ;904C            0670 DO_ICAX2 ;      Arg 6 = Aux Byte 2PAGE 3                                                                     904C 68         0675     PLA         ; discard high byte904D 68         0680     PLA         ; Aux byte904E 9D4B03     0685     STA ICAX2,X ; Store AUX2 in IOCB9051 88         0690     DEY         ; This should be zero args now...                0695 ;9052            0700 DO_CIO ;        IOCB is set, now execute...9052 84D4       0705     STY ZRET    ; Clear return value low9054 84D5       0710     STY ZRET+1  ; and high byte.9056 2056E4     0715     JSR CIOV    ; Engage, Mr Crusher.9059 1002       0720     BPL BYE     ; No error905B 84D4       0725     STY ZRET    ; Copy Y to return value                0730 ;905D            0735 BYE905D 60         0740     RTS                 0745 ;905E            0750     .END ASSEMBLY ERRORS: 0   24484 BYTES FREEPAGE 4    SYMBOLS                                                           905D BYE              1,345       3,720    #  3,735    =E456 CIOV          #  1,195       3,715     9016 DISPOSE          1,370       2,385    #  2,420       2,440       2,490     901C DO_CHANNEL       2,400    #  2,465     9052 DO_CIO           2,550       2,625       2,660    #  3,700     9044 DO_ICAX1      #  2,635     904C DO_ICAX2      #  2,670     9030 DO_ICBA       #  2,560     9039 DO_ICBL       #  2,595     9028 DO_ICCMD      #  2,525    =034A ICAX1         #  1,260       2,650    =034B ICAX2         #  1,265       3,685    =034C ICAX3         #  1,270    =034D ICAX4         #  1,275    =034E ICAX5         #  1,280    =034F ICAX6         #  1,285    =0345 ICBAH         #  1,235       2,570    =0344 ICBAL         #  1,230       2,580    =0349 ICBLH         #  1,255       2,605    =0348 ICBLL         #  1,250       2,615    =0342 ICCMD         #  1,220       2,540    =0341 ICDNO         #  1,215    =0340 ICHID         #  1,210    =0347 ICPTH         #  1,245    =0346 ICPTL         #  1,240    =0343 ICSTA         #  1,225     9000 INIT          #  1,315    =0340 IOCB          #  1,205       1,210       1,215       1,220       1,225                           1,230       1,235       1,240       1,245       1,250                           1,255       1,260       1,265       1,270       1,275                           1,280       1,285    =00D4 ZRET          #  1,185       1,325       1,330       3,705       3,710                           3,725    